## libdivide 1.0+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(libdivide C CXX)
include(CheckCXXCompilerFlag)
include(CMakePushCheckState)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -DLIBDIVIDE_ASSERTIONS_ON")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DLIBDIVIDE_ASSERTIONS_ON")

# By default enable release mode ###############################

string(TOUPPER "${CMAKE_BUILD_TYPE}" BUILD_TYPE)

if(NOT "${BUILD_TYPE}" MATCHES DEBUG)
    set(CMAKE_BUILD_TYPE Release)
endif()

# Enable GCC/Clang warnings ####################################

set(WALL_FLAGS "-Wall -Wno-unknown-pragmas -fstrict-aliasing")
check_cxx_compiler_flag("${WALL_FLAGS}" wall)

if(wall)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${WALL_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${WALL_FLAGS}")
endif()

# Check -msse2 compiler flag ###################################

cmake_push_check_state()
set(CMAKE_REQUIRED_FLAGS -Werror)
check_cxx_compiler_flag(-msse2 msse2)
cmake_pop_check_state()

if(msse2)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse2")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2")
    add_definitions(-DLIBDIVIDE_USE_SSE2)
endif()

# Build binaries ###############################################

find_package(Threads REQUIRED)

add_executable(tester libdivide_test.cpp)
add_executable(benchmark libdivide_benchmark.c)
add_executable(primes_benchmark primes_benchmark.cpp)

target_link_libraries(tester Threads::Threads)

# Enable testing ###############################################

enable_testing()
add_test(tester tester)
add_test(primes_benchmark primes_benchmark)

# By default install to /usr/local/install #####################

install(FILES libdivide.h DESTINATION ${CMAKE_INSTALL_PREFIX}/include)

=== debian/changelog ===
libdivide (1.0+dfsg1-2) unstable; urgency=medium

  * d/control: Set Architecture: all.

 -- Alexander GQ Gerasiov <gq@debian.org>  Thu, 24 Jan 2019 01:50:58 +0300

libdivide (1.0+dfsg1-1) unstable; urgency=low

  * Initial release (Closes: #918932)

 -- Alexander GQ Gerasiov <gq@debian.org>  Thu, 10 Jan 2019 21:23:29 +0300

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libdivide-$1\.tar\.gz/,\
repack,compression=xz,repacksuffix=+dfsg1,dversionmangle=s/\+dfsg\d*$// \
  https://github.com/ridiculousfish/libdivide/tags .*/v?(\d\S+)\.tar\.gz

## libdivide 1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -39,13 +39,17 @@
     add_definitions(-DLIBDIVIDE_USE_SSE2)
 endif()
 
-# Build binaries ###############################################
+# Build test programs ##########################################
 
 find_package(Threads REQUIRED)
 
-add_executable(tester libdivide_test.cpp)
-add_executable(benchmark libdivide_benchmark.c)
-add_executable(primes_benchmark primes_benchmark.cpp)
+add_executable(tester test/tester.cpp)
+add_executable(benchmark test/benchmark.c)
+add_executable(primes_benchmark test/primes_benchmark.cpp)
+
+target_include_directories(tester PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}")
+target_include_directories(benchmark PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}")
+target_include_directories(primes_benchmark PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}")
 
 target_link_libraries(tester Threads::Threads)

=== debian/changelog ===
libdivide (1.1-1) unstable; urgency=medium

  * New upstream version 1.1
  * d/watch, d/copyright: No need to repack sources anymore.

 -- Alexander GQ Gerasiov <gq@debian.org>  Tue, 02 Jul 2019 17:46:18 +0300

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libdivide-$1\.tar\.gz/,\
  https://github.com/ridiculousfish/libdivide/tags .*/v?(\d\S+)\.tar\.gz

## libdivide 3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
set(LIBDIVIDE_VERSION "3.0")
project(libdivide C CXX)

include(CheckCXXCompilerFlag)
include(CheckCXXSourceRuns)
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
include(CMakePushCheckState)

# Build options ################################################

option(BUILD_TESTS "Build the test programs" ON)
option(ENABLE_VECTOR_EXTENSIONS "Enable CPU vector instructions for test programs" ON)

# By default we automatically enable the widest vector
# instruction set supported by your x86/x64 CPU.
# But you can also force a specific vector instruction
# set using the options below.

option(LIBDIVIDE_SSE2   "Enable SSE2 vector instructions"   OFF)
option(LIBDIVIDE_AVX2   "Enable AVX2 vector instructions"   OFF)
option(LIBDIVIDE_AVX512 "Enable AVX512 vector instructions" OFF)

# By default enable release mode ###############################

if(NOT CMAKE_VERSION VERSION_LESS 3.9)
    get_property(isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
elseif(CMAKE_CONFIGURATION_TYPES)
    set(isMultiConfig TRUE)
endif()

if(NOT isMultiConfig AND NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

# Enable assertions in debug mode ##############################

string(TOUPPER "${CMAKE_BUILD_TYPE}" BUILD_TYPE)

if("${BUILD_TYPE}" MATCHES DEBUG)
    set(LIBDIVIDE_ASSERTIONS -DLIBDIVIDE_ASSERTIONS_ON)
endif()

# Check if x86/x64 CPU  ########################################

# Note that check_cxx_source_runs() must not be used when
# cross-compiling otherwise the following error will occur:
# CMake Error: TRY_RUN() invoked in cross-compiling mode, ...

if (BUILD_TESTS AND ENABLE_VECTOR_EXTENSIONS AND NOT CMAKE_CROSSCOMPILING)
    check_cxx_source_runs("
        int main()
        {
            #if !defined(__i386__) && \
                !defined(__x86_64__) && \
                !defined(_M_IX86) && \
                !defined(_M_X64)
                Compile error: not x86 CPU architecture
            #endif
            return 0;
        }"
        cpu_x86)

    if (cpu_x86)
        set(ENABLE_X86_VECTOR_EXTENSIONS ON)

        cmake_push_check_state()
        set(CMAKE_REQUIRED_FLAGS -Werror)
        check_cxx_compiler_flag(-march=native march_native)
        cmake_pop_check_state()

        if (march_native)
            # -march=native required for AVX2/AVX512 on x86
            set(NATIVE_FLAG -march=native)
        endif()
    endif()
endif()

# Disable auto vectorization ###################################

# We disable auto vectorization on x86 (and x64-64) in order
# to prevent the compiler from vectorizing our scalar benchmarks
# which would make the benchmark results less useful.

if(ENABLE_X86_VECTOR_EXTENSIONS)
    if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
        check_cxx_compiler_flag("-fno-vectorize" fno_vectorize)
        if(fno_vectorize)
            set(NO_VECTORIZE -fno-vectorize)
        endif()
    elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
        check_cxx_compiler_flag("-fno-tree-vectorize" fno_tree_vectorize)
        if(fno_tree_vectorize)
            set(NO_VECTORIZE -fno-tree-vectorize)
        endif()
    endif()
endif()

# Check if CPU supports AVX512/AVX2/SSE2 #######################

if(LIBDIVIDE_AVX512)
    set(LIBDIVIDE_VECTOR_EXT -DLIBDIVIDE_AVX512)
elseif(LIBDIVIDE_AVX2)
    set(LIBDIVIDE_VECTOR_EXT -DLIBDIVIDE_AVX2)
elseif(LIBDIVIDE_SSE2)
    set(LIBDIVIDE_VECTOR_EXT -DLIBDIVIDE_SSE2)
elseif(ENABLE_X86_VECTOR_EXTENSIONS)

    cmake_push_check_state()
    if(march_native)
        set(CMAKE_REQUIRED_FLAGS "-march=native")
    endif()

    check_cxx_source_runs("
        #include <immintrin.h>
        int main()
        {
            __m512i a = _mm512_set_epi32(1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0);
            __m512i b = _mm512_set_epi32(0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1);
            __m512i c = _mm512_add_epi32(a, b);
            __m512i d = _mm512_srai_epi32(c, 23);
            d = _mm512_shuffle_epi32(d, (_MM_PERM_ENUM) 0xB1);
            return 0;
        }"
        avx512)

    if(avx512)
        set(LIBDIVIDE_VECTOR_EXT -DLIBDIVIDE_AVX512)
    else()
        check_cxx_source_runs("
            #include <immintrin.h>
            int main()
            {
                __m256i a = _mm256_set_epi32(1, 0, 1, 0, 1, 0, 1, 0);
                __m256i b = _mm256_set_epi32(0, 1, 0, 1, 0, 1, 0, 1);
                b = _mm256_add_epi32(a, b);
                return 0;
            }"
            avx2)

        if(avx2)
            set(LIBDIVIDE_VECTOR_EXT -DLIBDIVIDE_AVX2)
        else()
            check_cxx_source_runs("
                #include <emmintrin.h>
                int main()
                {
                    __m128i a = _mm_set_epi32(1, 0, 1, 0);
                    __m128i b = _mm_set_epi32(0, 1, 0, 1);
                    b = _mm_add_epi32(a, b);
                    return 0;
                }"
                sse2)

            if(sse2)
                set(LIBDIVIDE_VECTOR_EXT -DLIBDIVIDE_SSE2)
            endif()
        endif()
    endif()

    cmake_pop_check_state()
endif()

# libdivide header-only library target #########################

add_library(libdivide INTERFACE)
add_library(libdivide::libdivide ALIAS libdivide)

target_compile_features(libdivide INTERFACE cxx_alias_templates)

target_include_directories(libdivide INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>)

install(FILES libdivide.h
        COMPONENT libdivide-header
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

# CMake find_package(libdivide) support ########################

install(TARGETS libdivide
        EXPORT libdivideConfig
        RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}")

export(TARGETS libdivide
       NAMESPACE libdivide::
       FILE "${CMAKE_CURRENT_BINARY_DIR}/libdivideConfig.cmake")

install(EXPORT libdivideConfig
        NAMESPACE libdivide::
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/libdivide")

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/libdivideConfigVersion.cmake"
    VERSION ${LIBDIVIDE_VERSION}
    COMPATIBILITY SameMajorVersion)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libdivideConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/libdivide")

# Build test programs ##########################################

if (BUILD_TESTS)
    find_package(Threads REQUIRED QUIET)

    add_executable(tester test/tester.cpp)
    add_executable(benchmark test/benchmark.c)
    add_executable(benchmark_branchfree test/benchmark_branchfree.cpp)

    target_link_libraries(tester libdivide Threads::Threads)
    target_link_libraries(benchmark libdivide)
    target_link_libraries(benchmark_branchfree libdivide)

    target_compile_options(tester PRIVATE "${NATIVE_FLAG}" "${NO_VECTORIZE}")
    target_compile_options(benchmark PRIVATE "${NATIVE_FLAG}" "${NO_VECTORIZE}")
    target_compile_options(benchmark_branchfree PRIVATE "${NATIVE_FLAG}" "${NO_VECTORIZE}")

    target_compile_definitions(tester PRIVATE "${LIBDIVIDE_ASSERTIONS}" "${LIBDIVIDE_VECTOR_EXT}")
    target_compile_definitions(benchmark PRIVATE "${LIBDIVIDE_ASSERTIONS}" "${LIBDIVIDE_VECTOR_EXT}")
    target_compile_definitions(benchmark_branchfree PRIVATE "${LIBDIVIDE_ASSERTIONS}" "${LIBDIVIDE_VECTOR_EXT}")
endif()

# Enable testing ###############################################

if (BUILD_TESTS)
    enable_testing()
    add_test(tester tester)
    add_test(benchmark_branchfree benchmark_branchfree)
endif()

=== debian/changelog ===
libdivide (3.0-1) unstable; urgency=medium

  * d/watch: Fix syntax.
  * New upstream version 3.0

 -- Alexander GQ Gerasiov <gq@debian.org>  Fri, 22 Nov 2019 01:40:56 +0300

libdivide (1.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No-change source-only rebuild to allow testing migration.

 -- Boyuan Yang <byang@debian.org>  Fri, 08 Nov 2019 14:07:59 -0500

=== debian/control ===
Source: libdivide
Priority: optional
Maintainer: Alexander GQ Gerasiov <gq@debian.org>
Build-Depends: debhelper (>= 11), cmake
Standards-Version: 4.3.0
Section: libs
Homepage: https://libdivide.com/
Vcs-Git: https://salsa.debian.org/debian/libdivide.git
Vcs-Browser: https://salsa.debian.org/debian/libdivide.git

Package: libdivide-dev
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: compile-time library for optimizing integer division
 libdivide allows you to replace expensive integer divides with comparatively
 cheap multiplication and bitshifts. Compilers usually do this, but only when
 the divisor is known at compile time. libdivide allows you to take advantage
 of it at runtime. The result is that integer division can become a lot faster.

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libdivide-$1\.tar\.gz/ \
  https://github.com/ridiculousfish/libdivide/tags .*/v?(\d\S+)\.tar\.gz

## libdivide 5.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
set(LIBDIVIDE_VERSION "5.2.0")
project(libdivide C CXX)

include(CheckCXXCompilerFlag)
include(CheckCCompilerFlag)
include(CheckCXXSourceCompiles)
include(CheckCXXSourceRuns)
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
include(CMakePushCheckState)

# Compile options ################################################

# Maximum warnings level & warnings as error
if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    if (CMAKE_CXX_COMPILER_FRONTEND_VARIANT STREQUAL "MSVC") # clang-cl
        add_compile_options("/W4;/WX;")
    else() # clang native
        add_compile_options("-Wall;-Wextra;-pedantic;-Werror")
    endif()
else()
    add_compile_options(
        "$<$<CXX_COMPILER_ID:MSVC>:/W4;/WX>"
        "$<$<CXX_COMPILER_ID:GNU>:-Wall;-Wextra;-pedantic;-Werror>"
        "$<$<CXX_COMPILER_ID:AppleClang>:-Wall;-Wextra;-pedantic;-Werror>"
    )
endif()

# Build options ################################################

if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  set(MAIN_PROJECT ON)
else()
  set(MAIN_PROJECT OFF)
endif()

option(LIBDIVIDE_BUILD_TESTS   "Build the test programs" "${MAIN_PROJECT}")
option(LIBDIVIDE_BUILD_FUZZERS "Build the fuzzers (requires clang)" OFF)

# By default we automatically enable vectors supported by
# the host CPU. You may also set these explicitly to OFF or ON.
set(LIBDIVIDE_SSE2  AUTO CACHE STRING  "Enable SSE2 vector instructions")
set(LIBDIVIDE_AVX2  AUTO CACHE STRING  "Enable AVX2 vector instructions")
set(LIBDIVIDE_AVX512 AUTO CACHE STRING "Enable AVX512 vector instructions")
set(LIBDIVIDE_NEON AUTO CACHE STRING "Enable ARM NEON vector instructions")

# By default enable release mode ###############################

if(NOT CMAKE_VERSION VERSION_LESS 3.9)
    get_property(isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
elseif(CMAKE_CONFIGURATION_TYPES)
    set(isMultiConfig TRUE)
endif()

if(NOT isMultiConfig AND NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

# Enable assertions in debug mode ##############################

string(TOUPPER "${CMAKE_BUILD_TYPE}" BUILD_TYPE)

if("${BUILD_TYPE}" MATCHES DEBUG)
    set(LIBDIVIDE_ASSERTIONS -DLIBDIVIDE_ASSERTIONS_ON)
endif()

# Try to warn about bogus vector conversions ###################
set(LIBDIVIDE_FLAGS)
check_cxx_compiler_flag(-fno-lax-vector-conversions WARN_VEC_CONVERSIONS)
if (WARN_VEC_CONVERSIONS)
    list(APPEND LIBDIVIDE_FLAGS "-fno-lax-vector-conversions")
endif()


# Check if x86/x64 CPU  ########################################

# Note that check_cxx_source_runs() must not be used when
# cross-compiling otherwise the following error will occur:
# CMake Error: TRY_RUN() invoked in cross-compiling mode, ...

if (LIBDIVIDE_BUILD_TESTS AND NOT CMAKE_CROSSCOMPILING)
    check_cxx_source_compiles("
        int main()
        {
            #if !defined(__i386__) && \
                !defined(__x86_64__) && \
                !defined(_M_IX86) && \
                !defined(_M_X64)
                #error not x86 CPU architecture
            #endif
            return 0;
        }"
        CPU_X86)
    check_cxx_source_compiles("
        #include <arm_neon.h>
        int main()
        {
            #if !defined(__ARM_NEON)
                #error not ARM NEON CPU architecture
            #endif
            return 0;
        }"
        CPU_ARM_NEON)
    if (CPU_X86 OR CPU_ARM_NEON)
        cmake_push_check_state()
        set(CMAKE_REQUIRED_FLAGS -Werror)
        check_cxx_compiler_flag(-march=native MARCH_NATIVE)
        cmake_pop_check_state()

        if (MARCH_NATIVE)
            list(APPEND LIBDIVIDE_FLAGS "-march=native")
        endif()
    endif()
endif()

# Disable auto vectorization ###################################

# We disable auto vectorization on x86 (and x64-64) in order
# to prevent the compiler from vectorizing our scalar benchmarks
# which would make the benchmark results less useful.

if(CPU_X86 OR CPU_ARM_NEON)
    # first check the C++ compiler
    if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
        check_cxx_compiler_flag("-fno-vectorize" fno_vectorize)
        if(fno_vectorize)
            set(NO_VECTORIZE -fno-vectorize)
        endif()
    elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
        check_cxx_compiler_flag("-fno-tree-vectorize" fno_tree_vectorize)
        if(fno_tree_vectorize)
            set(NO_VECTORIZE -fno-tree-vectorize)
        endif()
    endif()
    # then check the C compiler
    if("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
        check_c_compiler_flag("-fno-vectorize" fno_vectorize_c)
        if(fno_vectorize_c)
            set(NO_VECTORIZE_C -fno-vectorize)
        endif()
    elseif("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
        check_c_compiler_flag("-fno-tree-vectorize" fno_tree_vectorize_c)
        if(fno_tree_vectorize_c)
            set(NO_VECTORIZE_C -fno-tree-vectorize)
        endif()
    endif()
endif()

# Resolve any "auto" supported vector types ##################
# Note these use "check_cxx_source_runs" and not "check_cxx_source_compiles"
# because VC++ will compile AVX512 even though it's not available at runtime.
cmake_push_check_state()
# Need to convert from list to space-separated string.
string(REPLACE ";" " " CMAKE_REQUIRED_FLAGS "${LIBDIVIDE_FLAGS}")

# NEON
if (NOT LIBDIVIDE_NEON STREQUAL "AUTO")
    set(LIBDIVIDE_NEON_ENABLED "${LIBDIVIDE_NEON}")
else()
    set(NEON_TEST "
    #include <arm_neon.h>
    int main()
    {
        int32x4_t a = vdupq_n_s32(0);
        return *(int *)&a;
    }")
    if (CMAKE_CROSSCOMPILING)
        check_cxx_source_compiles("${NEON_TEST}" LIBDIVIDE_NEON_ENABLED)
    else()
        check_cxx_source_runs("${NEON_TEST}" LIBDIVIDE_NEON_ENABLED)
    endif()
endif()

# AVX512
if (NOT LIBDIVIDE_AVX512 STREQUAL "AUTO")
    set(LIBDIVIDE_AVX512_ENABLED "${LIBDIVIDE_AVX512}")
else()
    check_cxx_source_runs("
                #include <immintrin.h>
                int main()
                {
                    __m512i a = _mm512_setzero_si512();
                    return *(int *)&a;
                }"
                LIBDIVIDE_AVX512_ENABLED)
endif()

# AVX2
if (NOT LIBDIVIDE_AVX2 STREQUAL "AUTO")
    set(LIBDIVIDE_AVX2_ENABLED "${LIBDIVIDE_AVX2}")
else()
    # Need to use an AVX2 insn like srai, not just AVX.
    check_cxx_source_runs("
                #include <immintrin.h>
                int main()
                {
                    __m256i a = _mm256_srai_epi32(_mm256_setzero_si256(), 3);
                    return *(int *)&a;
                }"
                LIBDIVIDE_AVX2_ENABLED)
endif()

# SSE2
if (NOT LIBDIVIDE_SSE2 STREQUAL "AUTO")
    set(LIBDIVIDE_SSE2_ENABLED "${LIBDIVIDE_SSE2}")
else()
    check_cxx_source_runs("
                #include <emmintrin.h>
                int main()
                {
                    __m128i a = _mm_setzero_si128();
                    return *(int *)&a;
                }"
                LIBDIVIDE_SSE2_ENABLED)
endif()
cmake_pop_check_state()


# Populate LIBDIVIDE_VECTOR_EXT ##################
set(LIBDIVIDE_VECTOR_EXT "")
if(LIBDIVIDE_NEON_ENABLED)
    list(APPEND LIBDIVIDE_VECTOR_EXT "LIBDIVIDE_NEON")
endif()
if(LIBDIVIDE_AVX512_ENABLED)
    list(APPEND LIBDIVIDE_VECTOR_EXT "LIBDIVIDE_AVX512")
endif()
if(LIBDIVIDE_AVX2_ENABLED)
    list(APPEND LIBDIVIDE_VECTOR_EXT "LIBDIVIDE_AVX2")
endif()
if(LIBDIVIDE_SSE2_ENABLED)
    list(APPEND LIBDIVIDE_VECTOR_EXT "LIBDIVIDE_SSE2")
endif()

# libdivide header-only library target #########################

add_library(libdivide INTERFACE)
add_library(libdivide::libdivide ALIAS libdivide)

include(CMakeSanitize)

target_compile_features(libdivide INTERFACE cxx_alias_templates)

target_include_directories(libdivide INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>)

install(FILES libdivide.h
        COMPONENT libdivide-header
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

# CMake find_package(libdivide) support ########################

install(TARGETS libdivide
        EXPORT libdivideConfig
        RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}")

export(TARGETS libdivide
       NAMESPACE libdivide::
       FILE "${CMAKE_CURRENT_BINARY_DIR}/libdivideConfig.cmake")

install(EXPORT libdivideConfig
        NAMESPACE libdivide::
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/libdivide")

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/libdivideConfigVersion.cmake"
    VERSION ${LIBDIVIDE_VERSION}
    COMPATIBILITY SameMajorVersion)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libdivideConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/libdivide")

# Build test programs ##########################################

if (LIBDIVIDE_BUILD_TESTS)
    find_package(Threads REQUIRED QUIET)

    add_executable(tester test/tester.cpp)
    add_executable(test_c99 test/test_c99.c)
    add_executable(fast_div_generator test/fast_div_generator.cpp)
    add_executable(benchmark test/benchmark.cpp)
    add_executable(benchmark_branchfree test/benchmark_branchfree.cpp)

    target_link_libraries(tester libdivide Threads::Threads)
    target_link_libraries(test_c99 libdivide)
    target_link_libraries(fast_div_generator libdivide)
    target_link_libraries(benchmark libdivide)
    target_link_libraries(benchmark_branchfree libdivide)

    target_compile_options(tester PRIVATE "${LIBDIVIDE_FLAGS}" "${NO_VECTORIZE}")
    target_compile_options(test_c99 PRIVATE "${LIBDIVIDE_FLAGS}" "${NO_VECTORIZE}")
    target_compile_options(fast_div_generator PRIVATE "${LIBDIVIDE_FLAGS}" "${NO_VECTORIZE}")
    target_compile_options(benchmark PRIVATE "${LIBDIVIDE_FLAGS}" "${NO_VECTORIZE_C}")
    target_compile_options(benchmark_branchfree PRIVATE "${LIBDIVIDE_FLAGS}" "${NO_VECTORIZE}")
    set_property(TARGET benchmark_branchfree PROPERTY CXX_STANDARD 11)
    set_property(TARGET test_c99 PROPERTY C_STANDARD 99)

    target_compile_definitions(tester PRIVATE "${LIBDIVIDE_ASSERTIONS}" "${LIBDIVIDE_VECTOR_EXT}")
    target_compile_definitions(test_c99 PRIVATE "${LIBDIVIDE_ASSERTIONS}" "${LIBDIVIDE_VECTOR_EXT}")
    target_compile_definitions(fast_div_generator PRIVATE "${LIBDIVIDE_ASSERTIONS}" "${LIBDIVIDE_VECTOR_EXT}")
    target_compile_definitions(benchmark PRIVATE "${LIBDIVIDE_ASSERTIONS}" "${LIBDIVIDE_VECTOR_EXT}")
    target_compile_definitions(benchmark_branchfree PRIVATE "${LIBDIVIDE_ASSERTIONS}" "${LIBDIVIDE_VECTOR_EXT}")
endif()

# Enable testing ###############################################

if (LIBDIVIDE_BUILD_TESTS)
    include(CTest)
    enable_testing()

    add_test(tester tester)
    # cmake won't actually build the tests before it tries to run them
    add_test(build_tester "${CMAKE_COMMAND}" --build ${CMAKE_BINARY_DIR} --target tester)
    set_tests_properties(tester PROPERTIES DEPENDS "build_tester")

    add_test(test_c99 test_c99)
    add_test(build_test_c99 "${CMAKE_COMMAND}" --build ${CMAKE_BINARY_DIR} --target test_c99)
    set_tests_properties(test_c99 PROPERTIES DEPENDS "build_test_c99")

    # Only benchmark in release builds.
    if("${BUILD_TYPE}" MATCHES RELEASE)
        add_test(benchmark_branchfree benchmark_branchfree)
        add_test(build_benchmark_branchfree "${CMAKE_COMMAND}" --build ${CMAKE_BINARY_DIR} --target benchmark_branchfree)
        set_tests_properties(benchmark_branchfree PROPERTIES DEPENDS "build_benchmark_branchfree")
    endif()
endif()

# Build the fuzzers (requires clang) ###########################

if (LIBDIVIDE_BUILD_FUZZERS)
    if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        set(fuzzflags "-fsanitize=fuzzer,address")

        add_executable(fuzzer_scalar test/fuzzer_scalar.cpp)
        target_compile_features(fuzzer_scalar PRIVATE cxx_std_17)

=== debian/changelog ===
libdivide (5.2.0-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release. (Closes: #1072368, #1113139, #1114171)
  * debian/control: Bump debhelper from old 11 to 13.
  * debian/control: Drop dependency on ${shlibs:Depends}, this is
    a devel package.
  * debian/control: Mark binary package as Section: libdevel.
  * Update standards version to 4.7.3, no changes needed.
  * debian/watch: Update to version 5.
  * debian/rules: Add extra build flags -Wno-error=pedantic
    -Wno-error=maybe-uninitialized to avoid build failures.
  * debian/patches/:
    + 0001-CMakeLists.txt-Use-arch-indep-.cmake-install-locatio.patch:
      Add patch to fix .cmake files being installed into arch-dep locations
      for the arch:all binary package.

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use secure copyright file specification URI.
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Use canonical URL in Vcs-Browser.

 -- Boyuan Yang <byang@debian.org>  Wed, 31 Dec 2025 11:06:08 -0500

=== debian/control ===
Source: libdivide
Section: libs
Maintainer: Alexander GQ Gerasiov <gq@debian.org>
Build-Depends: debhelper-compat (= 13), cmake
Standards-Version: 4.7.3
Homepage: https://libdivide.com/
Vcs-Git: https://salsa.debian.org/debian/libdivide.git
Vcs-Browser: https://salsa.debian.org/debian/libdivide

Package: libdivide-dev
Architecture: all
Section: libdevel
Depends: ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: foreign
Description: compile-time library for optimizing integer division
 libdivide allows you to replace expensive integer divides with comparatively
 cheap multiplication and bitshifts. Compilers usually do this, but only when
 the divisor is known at compile time. libdivide allows you to take advantage
 of it at runtime. The result is that integer division can become a lot faster.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

export DEB_CXXFLAGS_MAINT_APPEND = -Wno-error=pedantic -Wno-error=maybe-uninitialized

%:
	dh $@

=== debian/watch ===
Version: 5

Source: https://github.com/ridiculousfish/libdivide/tags
Matching-Pattern: .*/v?(\d\S+)\.tar\.gz
Filenamemangle: s/.+\/v?(\d\S+)\.tar\.gz/libdivide-$1\.tar\.gz/
